function Y=CXCor_multipleSensor(Z)
[row, col] = size(Z);

num_sensor = row/4;

Pres = [];
VX = [];
VY = [];
VZ = [];
for n = 1 : num_sensor
    Pres = [Pres; Z((n-1)*4+1,:)];
    VX = [VX; Z((n-1)*4+2,:)];
    VY = [VY; Z((n-1)*4+3,:)];
    VZ = [VZ; Z((n-1)*4+4,:)];
end
clear n;
Pres = Pres';
VX = VX';
VY = VY';
VZ = VZ';

Y = zeros(size(Z));
for n = 1 : num_sensor
    
    i=1;
    while Pres(i,n)*Pres(i+1,n) > 0
        i = i + 1;
    end
    zcross1 = i;
    
    i2=i+1;
    
    while Pres(i2,n)*Pres(i2+1,n) > 0
        i2 = i2 + 1;
    end
    zcross2 = i2;
    
    Period = zcross2-zcross1 + 1;
    % length_crosscorr = 2*Period - 1;
    
    Pres_trunc = Pres(zcross1:zcross2,n);
    VX_trunc = VX(zcross1:zcross2,n);
    VY_trunc = VY(zcross1:zcross2,n);
    VZ_trunc = VZ(zcross1:zcross2,n);
    
    [PVx, PVxpos] = max(xcorr(Pres_trunc, VX_trunc));
    [PVy, PVypos] = max(xcorr(Pres_trunc, VY_trunc));
    [PVz, PVzpos] = max(xcorr(Pres_trunc, VZ_trunc));
    
    if PVxpos > Period
        shiftx = PVxpos - Period;
        VX_shifted = [VX(end-shiftx+1:end,n); VX(1:end-shiftx,n)];
    elseif PVxpos < Period
        shiftx = abs(PVxpos - Period);
        VX_shifted = [VX(shiftx+1:end,n); VX(1:shiftx,n)];
    else
        VX_shifted = VX(:,n);
    end
    
    if PVypos > Period
        shifty = PVypos - Period;
        VY_shifted = [VY(end-shifty+1:end,n); VY(1:end-shifty,n)];
    elseif PVypos < Period
        shifty = abs(PVypos - Period);
        VY_shifted = [VY(shifty+1:end,n); VY(1:shifty,n)];
    else
        VY_shifted = VY(:,n);
    end
    
    if PVzpos > Period
        shiftz = PVzpos - Period;
        VZ_shifted = [VZ(end-shiftz+1:end,n); VZ(1:end-shiftz,n)];
    elseif PVzpos < Period
        shiftz = abs(PVzpos - Period);
        VZ_shifted = [VZ(shiftz+1:end,n); VZ(1:shiftz,n)];
    else
        VZ_shifted = VZ(:,n);
    end
    
    Y((n-1)*4+1,:) = Pres(:,n)';
    Y((n-1)*4+2,:) = VX_shifted';
    Y((n-1)*4+3,:) = VY_shifted';
    Y((n-1)*4+4,:) = VZ_shifted';
    
%     = [Y; Pres(:,n)'; ; VY_shifted'; VZ_shifted']

end

%     if Pres(i,1) < 0
%         flag = 0;
%         zcorss1 = i;
%     end
%
end