function [Data,P,c,fc,resol,doa]=distributedSensor(N,Ps,A,f,T,nv,pos)

%Source Position 1
%*************************
%A        amplitude

[m,n] = size (pos); %n = number of sensors
doa = Ps*ones(1, n) - pos; %doa is the difference between sensor positions and source
[phi,psi,Radio] = cart2sph(doa(1,:),doa(2,:),doa(3,:));

%Directional vector for source k
uk=[cos(phi).*cos(psi);sin(phi).*cos(psi);sin(psi)];

%Directional response vector for source k
hk=[ones(1,n);uk]; %% STOPPING POINT

%Signal waveform 1
%*************************
c=340; %speed of sound, m/s
fc= f;
Ts= 1/T;

tau=((Radio)/c)';
t=0:Ts:0.1;
%s1=A*sin(2*pi*fc*(t-tau1));
S=A*sin(2*pi*fc*(ones(n,1)*t-tau*ones(1,length(t))));


%Sensor position
%*************************
P=pos;
% m=size(P,2)

%Phase information delay vector
%*************************
P=P-P; %delay wrt itself is zero for the array
% delayk = - P'*uk/c;
% ap= exp(-j*2*pi*fc*delayk)   
 

%Array steering vector
%*************************
% ak=zeroes(4*n,n)
% ak = [];
% for i=1:n
%     temp = kron(ap(:,i),hk(:));
%     ak = [ak;temp];
% end


ak=hk(:);


%Measurement generation
%*************************

% S=s*[
mod = zeros(4*n,n);
for i=1:n
    for j = 1:4
        mod(4*i-4+j,i) = 1;
    end
end
mod;

S = mod*S;
    
%Single source
%Sc = repmat(S,n,1)
Data =(ak*ones(1,length(t))).*S+1*nv*randn(4*n,length(S)); % Problems with ak*S

resol=40;